<?php

namespace S2lowLegacy\Class\actes;

use S2lowLegacy\Class\IWorker;
use Exception;

class ActesStoreEnveloppeWorker implements IWorker
{
    public const QUEUE_NAME = 'actes-store-enveloppe';

    public function getQueueName()
    {
        return self::QUEUE_NAME;
    }

    private $actesEnvelopeStorage;

    public function __construct(ActesEnvelopeStorage $actesEnvelopeStorage)
    {
        $this->actesEnvelopeStorage = $actesEnvelopeStorage;
    }

    public function getData($id)
    {
        return $id;
    }

    public function getAllId()
    {
        return $this->actesEnvelopeStorage->getAllEnveloppeIdToStore();
    }

    /**
     * @param $data
     * @return void
     * @throws Exception
     */
    public function work($data)
    {
        $this->actesEnvelopeStorage->storeNextFileById($data);
    }

    public function getMutexName($data)
    {
        return sprintf("%s-%s", self::QUEUE_NAME, $data);
    }

    public function isDataValid($data)
    {
        return true;
    }

    /**
     * @return void
     */
    public function start()
    {
        // TODO: Implement start() method.
    }

    /**
     * @return void
     */
    public function end()
    {
        // TODO: Implement end() method.
    }
}
